#!/usr/bin/perl
#brainfuck-interpreter in perl
use strict;
use warnings;
use Switch;

my (@code, @array);
my ($pointer, $tmp, $pos, $switch, $length, $code);

if ($ARGV[0]){
	open my $infile, "<", $ARGV[0] or die "Couldn't open $ARGV[0] $!";
	@code = <$infile>;
	close $infile;
}
else{
	@code = <STDIN>;
}
$code = join "", @code;
$length = length($code);

undef @code;
for(my $i=0; $i<$length; $i++){
	push @code, substr $code, $i, 1;
	push @array, 0;
}
$pointer = 0;
$pos = 0;

for  ($pos=0; $pos<$length; $pos++){
	switch($code[$pos]){
		case ">"	{$pointer++}
		case "<"	{$pointer--}
		case "+"	{$array[$pointer]++}
		case "-"	{$array[$pointer]--}
		case ","	{read(STDIN, $tmp, 1); $array[$pointer] = ord($tmp)}
		case "."	{print(chr($array[$pointer]))}
		case "["	{
			if (!$array[$pointer]){
				$switch = 0;
				for(my $i = $pos+1; $i<$length; $i++){
					if ($code[$i] eq "]"){
						if(!$switch){
							$pos = $i;
							last;
						}
						$switch--;
					}
					$switch++ if($code[$i] eq "[");
				}
			}
		}
		case "]"	{
			if($array[$pointer]){
				my $swtch = 0;
				for(my $i = $pos-1; $i>=0; $i--){
					if($code[$i] eq "["){
						if(!$switch){
							$pos = $i;
							last;
						}
						$switch--;
					}
					$switch++ if($code[$i] eq "]");
				}
			}
		}
	}
}
